"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createTransition = createTransition;

var _match_route_pattern = require("./match_route_pattern.js");

function createTransition(pattern, handler) {
  return async function transition(location) {
    const queryParameters = (0, _match_route_pattern.matchRoutePattern)(pattern, location.pathname + location.search);

    if (!queryParameters) {
      return null;
    }

    return await handler(queryParameters);
  };
}