"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.matchRoutePattern = matchRoutePattern;

function matchRoutePattern(pattern, fullUrl) {
  const [url, query] = fullUrl.split("?");
  const names = [];
  const urlParamsRegexpString = pattern.replace(/:([^/]+)/g, name => {
    names.push(name.replace(/^:/, ""));
    return "([^/]+)";
  }).replace(/\//g, "\\/");
  const urlParamsRegexp = new RegExp(`^${urlParamsRegexpString}$`);
  const urlParamsMatches = urlParamsRegexp.exec(url);

  if (!urlParamsMatches) {
    return null;
  }

  const queryParams = Array.from(new URLSearchParams(query || "").entries());
  const urlParams = urlParamsMatches.slice(1).map((value, index) => [names[index], value]);
  const paramsObject = [...queryParams, ...urlParams].reduce((acc, [key, value]) => {
    acc[key] = value;
    return acc;
  }, {});
  return paramsObject;
}